/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved   */
/* get formatted patient record into args.   */
/*----------------------------------------------------------------------------
 * getfpatv()is used by the demo programs to read variable length records
 * from the patient.var file.
 *---------------------------------------------------------------------------*/

#include <stdio.h>
#include "cbtree.h"
#include "patrec.str"

void getfpatv(pr, fd, btcp)
PATREC *pr;   /* patient record pointer */
int   fd;
BTC *btcp;
{
   extern long  lseek();
   extern uword btsizvar();
   uword szrec;
   char *cp2;
   char buffer[SZ_PATREC];
   register char *cp1;

   if ((szrec = btsizvar(fd, btcp->btloc)) == ERR)
      ckerror( CK_INDX, "GETFPATV.C: illegal record offset");
   if (btseekv(fd, btcp->btloc, szrec) == -1L)  /* variable length seek */
      ckerror(- CK_SEEK, "GETFPATV.C: btseekv");
   if (read(fd, buffer, szrec) == ERR)
      ckerror(- CK_READ, "GETFPATV.C: fd, buffer, szrec");

   /* now transfer variable length record to fixed-length PATREC */
   memset(pr, NUL, SZ_PATREC);     /* clear it out first */
   cp1 = buffer;
   cp2 = pr->lname;
   while (*cp1 != ',')  /* last name */
      *cp2++ = *cp1++;

   cp1 += 2;      /* skip over space */
   cp2 = pr->fname;
   while (*cp1 != ' ')     /* first name */
      *cp2++ = *cp1++;

   ++cp1;
   cp2 = pr->minit;
   while (*cp1 != '\n')    /* middle initial */
      *cp2++ = *cp1++;

   ++cp1;
   cp2 = pr->addr;
   while (*cp1 != '\n')    /* street address */
      *cp2++ = *cp1++;

   ++cp1;
   cp2 = pr->hphone;
   while (*cp1 != '\n')    /* home phone */
      *cp2++ = *cp1++;

   ++cp1;
   cp2 = pr->ssn;
   while (*cp1 != '\n')    /* social security number */
      *cp2++ = *cp1++;

}
